//+------------------------------------------------------------------+
//|                     Kahler Digital Stochastic V2 by Sohocool.mq4 |
//|                                                        July 2013 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "SOHOCOOL"
#property link      "http://sohocool.over-blog.com"

#property indicator_separate_window
#property  indicator_buffers 4

#property indicator_minimum -1
#property indicator_maximum 1

#property indicator_color1 LawnGreen
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
#property indicator_color3 Blue
#property indicator_width3 2
#property indicator_color4 Blue
#property indicator_width4 1

#property indicator_level1 0.8
#property indicator_level2 0
#property indicator_level3 -0.8


extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int Donchian =5;
 int Ksmooth =3;
extern int Smooth =5;
extern int ModeSmooth =1;
bool UseSound=false;
bool AlertSound=false;
string SoundFileBuy ="alert2.wav";
string SoundFileSell="email.wav";
bool SendMailPossible = false;
extern int SIGNAL_BAR = 1;
bool SoundBuy  = False;
bool SoundSell = False;
//---- buffers
double slope1[];
double slope2[];
double slope3[];
double ExtMapBuffer1[];
double ExtMapBuffer[];
double Trend[];
string indicatorFileName;
bool   returnBars;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_HISTOGRAM);// #Stochastic_Digital_Kahler_V20c
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(0,slope1);
   SetIndexBuffer(1,slope2);
   SetIndexBuffer(2,slope3);
   
   SetIndexBuffer(3,ExtMapBuffer1);
   SetIndexBuffer(4,ExtMapBuffer);
   SetIndexBuffer(5,Trend);

      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);

   string short_name = "Digital Stochastic V2b";
   IndicatorShortName (short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { slope1[0] = limit+1; return(0); } 
         if (TimeFrame!=_Period)
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for(i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
               slope1[i]        = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Donchian,Smooth,ModeSmooth,SIGNAL_BAR,0,y);
               slope2[i]        = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Donchian,Smooth,ModeSmooth,SIGNAL_BAR,1,y);
               slope3[i]        = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Donchian,Smooth,ModeSmooth,SIGNAL_BAR,2,y);
               ExtMapBuffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Donchian,Smooth,ModeSmooth,SIGNAL_BAR,3,y);
            } 
            return(0);         
         }            

   
   for(i=0; i<limit; i++) 
   {
   
  
      double stoch0 = iStochastic (NULL, 0, Donchian, 1, 1, MODE_SMA, 0, 0, i);
      double stoch1 = iStochastic (NULL, 0, Donchian, 1, Ksmooth, MODE_SMA, 0, 0, i);
      double slope = (22*stoch1 + 8*stoch0)/30;
      ExtMapBuffer[i] = slope;
    
    
      Trend[i]=Trend[i+1];
      
      if (ExtMapBuffer[i]> 50 ) Trend[i]=1;
      if (ExtMapBuffer[i]< 50 ) Trend[i]=-1; 
      
      }
    
  
   for(i=0; i<limit; i++) 
   {
      
      ExtMapBuffer1[i]=iMAOnArray(Trend,0,Smooth,0,ModeSmooth,i);
      
      }
    ////////////////////////////////
    
      for(i=0; i<limit; i++)
   
   {
     slope1[i]=slope1[i+1];
     slope2[i]=slope2[i+1];
      
         if (( ExtMapBuffer1[i]> ExtMapBuffer1[i+1]) || (ExtMapBuffer1[i]== ExtMapBuffer1[i+1] && ExtMapBuffer1[i]>0))
         
         {slope1[i] =  ExtMapBuffer1[i];
         slope2[i]=EMPTY_VALUE ;
         slope3[i]=EMPTY_VALUE ;
         }
         else
          if  (( ExtMapBuffer1[i]< ExtMapBuffer1[i+1]) || (ExtMapBuffer1[i]== ExtMapBuffer1[i+1] && ExtMapBuffer1[i]<0))
          {slope2[i] =  ExtMapBuffer1[i];
          slope1[i]=EMPTY_VALUE;
          slope3[i]=EMPTY_VALUE ;
          }
          else
          {slope3[i]=ExtMapBuffer1[i];
          slope1[i]=EMPTY_VALUE;
          slope2[i]=EMPTY_VALUE;}
        
   }   
  
 //+------------------------------------------------------------------+ 
        string  message  =  StringConcatenate("#Stochastic_Digital_Kahler_V20c (", Symbol(), ", ", Period(), ")  -  BUY!!!" ,"-" ,TimeToStr(TimeLocal(),TIME_SECONDS)); 
        string  message2 =  StringConcatenate("#Stochastic_Digital_Kahler_V20c (", Symbol(), ", ", Period(), ")  -  SELL!!!","-"  ,TimeToStr(TimeLocal(),TIME_SECONDS)); 
               
        if (slope1[SIGNAL_BAR] != EMPTY_VALUE && slope1[SIGNAL_BAR] != 0 && SoundBuy)
         {
         SoundBuy = False;
            if (UseSound) PlaySound (SoundFileBuy);
               if(AlertSound){         
               Alert(message);                             
               if (SendMailPossible) SendMail(Symbol(),message); 
            }              
         } 
      if (!SoundBuy && (slope1[SIGNAL_BAR] == EMPTY_VALUE || slope1[SIGNAL_BAR] == 0)) SoundBuy = True;  
            
  
     if (slope2[SIGNAL_BAR] != EMPTY_VALUE && slope2[SIGNAL_BAR] != 0 && SoundSell)
         {
         SoundSell = False;
            if (UseSound) PlaySound (SoundFileSell); 
             if(AlertSound){                    
             Alert(message2);             
             if (SendMailPossible) SendMail(Symbol(),message2); 
             }            
         } 
      if (!SoundSell && (slope2[SIGNAL_BAR] == EMPTY_VALUE || slope2[SIGNAL_BAR] == 0)) SoundSell = True; 
      
       //+------------------------------------------------------------------+    
   return(0);
  }
//+------------------------------------------------------------------+